<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_request_provider".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanRequestProvider".
 *
 * Columns in table "scan_request_provider" available as properties of the model,
 * followed by relations of table "scan_request_provider" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property string $provider_name
 * @property integer $is_primary
 * @property integer $scan_request_practice_id
 * @property integer $primary_specialty_id
 *
 * @property ScanRequestPractice $scanRequestPractice
 * @property ScanResultProvider[] $scanResultProviders
 * @property ScanStatsProvider[] $scanStatsProviders
 */
abstract class BaseScanRequestProvider extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_request_provider';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanRequestProvider|ScanRequestProviders', $n);
    }

    public static function representingColumn()
    {
        return 'provider_name';
    }

    public function rules()
    {
        return array(
            array('scan_request_practice_id', 'required'),
            array('provider_id, is_primary, scan_request_practice_id, primary_specialty_id', 'numerical', 'integerOnly' => true),
            array('provider_name', 'length', 'max' => 255),
            array('provider_id, provider_name, is_primary, primary_specialty_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, provider_name, is_primary, scan_request_practice_id, primary_specialty_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'scanRequestPractice' => array(self::BELONGS_TO, 'ScanRequestPractice', 'scan_request_practice_id'),
            'scanResultProviders' => array(self::HAS_MANY, 'ScanResultProvider', 'scan_request_provider_id'),
            'scanStatsProviders' => array(self::HAS_MANY, 'ScanStatsProvider', 'scan_input_provider_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'provider_name' => Yii::t('app', 'Provider Name'),
            'is_primary' => Yii::t('app', 'Is Primary'),
            'scan_request_practice_id' => null,
            'primary_specialty_id' => Yii::t('app', 'Primary Specialty'),
            'scanRequestPractice' => null,
            'scanResultProviders' => null,
            'scanStatsProviders' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('provider_name', $this->provider_name, true);
        $criteria->compare('is_primary', $this->is_primary);
        $criteria->compare('scan_request_practice_id', $this->scan_request_practice_id);
        $criteria->compare('primary_specialty_id', $this->primary_specialty_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
